oc3board.screenshoot =
{
    makeVisibleScreenshoot: function()
    {
        var doc = getBrowser().selectedBrowser.contentDocument;
        var win = getBrowser().selectedBrowser.contentWindow;
    
        var left = win.scrollX;
        var top = win.scrollY;
    
        var height = 0;
        var width = 0;
    
        if (doc.compatMode == "CSS1Compat")
        {
            height = doc.documentElement.clientHeight;
            width = doc.documentElement.clientWidth;
        }
        else
        {
            height = doc.body.clientHeight;
            width = doc.body.clientWidth;
        }
        

        var canvas = oc3board.screenshoot.createCanvas(left, top, width, height);
        //var filename = oc3board.screenshoot.saveImage(canvas.toDataURL("image/png", ""));
        //document.location.href = canvas.toDataURL("image/png", "");
        
        return canvas;
    },
  
    makeFullScreenshoot: function()
    {
        var doc = getBrowser().selectedBrowser.contentDocument;
    
        var left = 0;
        var top = 0;
        var width = doc.documentElement.scrollWidth;
        var height = doc.documentElement.scrollHeight;  

        try
        {
            var canvas = oc3board.screenshoot.createCanvas(left, top, width, height);
            //var filename = oc3board.screenshoot.saveImage(canvas.toDataURL("image/png", ""));
            //document.location.href = canvas.toDataURL("image/png", ""); 
        }
        catch(e)
        {
            alert(e);
        }
        
        return canvas;
    },
    
    createCanvas: function(left, top, width, height)
    {
        var win = getBrowser().selectedBrowser.contentWindow;        

        var canvas = document.createElementNS("http://www.w3.org/1999/xhtml", "html:canvas");
        canvas.style.width = canvas.style.maxwidth = String(width) + "px";
        canvas.style.height = canvas.style.maxheight = String(height) + "px";
        canvas.width = width;
        canvas.height = height;

        var ctx = canvas.getContext("2d");
        ctx.clearRect(left, top, width, height);
        ctx.save();
        ctx.drawWindow(win, left, top, width, height, "rgb(255,255,255)");
        ctx.restore();

        return canvas;
    },
    
    saveImage: function(dataUrl)
    {
        var image = window.content.document.createElement("img");
        image.setAttribute("style", "display: none");
        image.setAttribute("id", "screengrab_buffer");
        image.setAttribute("src", dataUrl);

        var body = window.content.document.getElementsByTagName("html")[0];
        body.appendChild(image);
        
        var doc = window.content.document;

        urlSecurityCheck(image.src, doc.nodePrincipal);

        try
        {
            var filename = "C:\\Windows\\Temp\\oc3board_web_page_" + new Date().getTime() + ".png";
            Canvas2Image.saveAsPNG(dataUrl);       
        }
        catch(e)
        {
            alert(e);
        }
        
        
        return filename;
    },
    
    saveAsPNG : function(canvas)
    {        
        var strData = oScaledCanvas.toDataURL("image/png");        
        saveFile(strData.replace("image/png", strDownloadMime));

        return true;  
    },
    

};